/*
 * SortsTest.java
 * JUnit based test
 *
 * Created on December 11, 2006, 10:02 PM
 */

package galago;

import galago.*;
import junit.framework.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;

/**
 *
 * @author trevor
 */
public class SortsTest extends TestCase {
        Integer[] integerArray = {  4379,  773,  5980,  7171,  8569,  8573,  2617,  4403,  6451,  6166,  2219, 
                                    5102,  4523,  6848,  9378,  579,  7837,  2899,  2632,  743,  9824,  6330, 
                                    6593,  5214,  7461,  433,  9254,  663,  7941,  8393,  5617,  2293,  131, 
                                    5331,  9208,  6223,  790,  246,  432,  937,  1693,  382,  3950,  1400, 
                                    5679,  8561,  1428,  2798,  2889,  1396,  8134,  1456,  4557,  3930,  5726, 
                                    2630,  6720,  7158,  4055,  4177,  361,  3166,  4774,  8906,  6148,  3547, 
                                    4891,  9807,  4907,  6969,  4397,  4504,  1294,  9748,  6284,  8700,  9086, 
                                    4546,  1392,  171,  8706,  8785,  8374,  4737,  1572,  1717,  1261,  5971, 
                                    5047,  4267,  8820,  4357,  2791,  8619,  2319,  2378,  7152,  3722,  6659, 
                                    7455,  1298,  6757,  380,  522,  2017,  5424,  2328,  8828,  2332,  7545, 
                                    4542,  3770,  304,  4510,  7902,  1109,  2465,  1354,  3374,  2420,  7893, 
                                    5832,  9760,  7225,  5359,  1823,  6055,  604,  159,  6335,  862,  6905, 
                                    2476,  6976,  8849,  3616,  2212,  5868,  1418,  6551,  8783,  9404,  5796, 
                                    464,  2379,  4235,  9837,  6398,  1372,  4362,  1837,  920,  3148,  8483, 
                                    2220,  3814,  3292,  9136,  5806,  6183,  5575,  6004,  6267,  3857,  1941, 
                                    6295,  2217,  4838,  6658,  353,  5235,  3551,  3046,  2579,  4244,  7938, 
                                    9972,  1712,  4842,  9844,  8809,  5527,  823,  4193,  3355,  8755,  1416, 
                                    5602,  5307,  1464,  1726,  646,  4014,  7135,  2106,  1325,  4991,  3344, 
                                    5769,  2872,  836,  8136,  8463,  6173,  7155,  3082,  7270,  1851,  4239, 
                                    5582,  4722,  9092,  6955,  1476,  2825,  2516,  9751,  2875,  2552,  567, 
                                    1960,  960,  7443,  598,  8316,  6658,  5360,  5254,  5572,  1580,  778, 
                                    9364,  484,  8358,  806,  2527,  3070,  7916,  9117,  2791,  1641,  3079, 
                                    8422,  2681,  877,  9937,  8363,  3551,  7072,  4642,  8130,  645,  4862, 
                                    3501,  5000,  5488,  5002,  4168,  9485,  4484,  4995,  2353,  6822,  1460, 
                                    3080,  3918,  1167,  9394,  2126,  3203,  2677,  5431,  6885,  193,  918, 
                                    6572,  7963,  7969,  4138,  6665,  6148,  8639,  1654,  3603,  7150,  5810, 
                                    7551,  9333,  5668,  9765,  4378,  1200,  314,  3312,  5546,  9088,  308, 
                                    8450,  4310,  4296,  1837,  5313,  8947,  9227,  647,  3122,  3376,  534, 
                                    3093,  1890,  464,  2634,  8974,  5543,  658,  4748,  6198,  2344,  4094, 
                                    9555,  3007,  8144,  2223,  8147,  2957,  5156,  1902,  72,  5762,  3877, 
                                    8986,  3058,  2455,  3870,  1129,  8408,  2326,  7568,  5011,  3806,  1019, 
                                    4451,  8505,  5268,  377,  4891,  9627,  8306,  9173,  432,  7771,  682, 
                                    4802,  2096,  8940,  6749,  9525,  3176,  1349,  119,  379,  2293,  4820, 
                                    3502,  7849,  3939,  7287,  4225,  7329,  8281,  843,  2251,  6873,  1670, 
                                    8530,  6176,  3364,  1430,  167,  2894,  3473,  4281,  3441,  8778,  9624, 
                                    8891,  4779,  7248,  4893,  4453,  1200,  9708,  2655,  6446,  238,  8621, 
                                    4105,  8498,  8902,  9794,  6059,  8127,  1283,  6170,  606,  9921,  7116, 
                                    8091,  2716,  249,  2313,  3627,  9934,  5320,  7015,  262,  7418,  5260, 
                                    9957,  3629,  7659,  1072,  266,  2318,  4368,  1212,  4089,  1470,  1684, 
                                    4842,  9768,  2806,  4665,  7922,  8684,  7445,  1223,  2462,  3504,  4185, 
                                    4453,  5753,  1063,  3242,  2302,  1122,  6325,  3385,  1293,  5124,  4830, 
                                    1929,  5686,  7976,  4386,  2966,  3812,  7477,  7142,  1414,  1871,  3009, 
                                    769,  5054,  5951,  2867,  979,  5545,  8883,  129,  1296,  7859,  166, 
                                    8917,  4685,  85,  2597,  8779,  8762,  8609,  2149,  9012,  9320,  580, 
                                    7003,  5255,  6101,  6902,  1705,  9120,  3974,  854,  2801,  9420,  3872, 
                                    7391,  2056,  5023,  8675,  3182,  6401,  856,  2827,  6852,  3834,  2064, 
                                    4968,  5545,  5994,  8829,  7195,  9835,  3500,  3533,  4014,  4315,  1949, 
                                    1637,  2047,  3307,  175,  5004,  2106,  123,  2117,  397,  8354,  5750, 
                                    4770,  6377,  2094,  9454,  4494,  3751,  7418,  1139,  9712,  5482,  8924, 
                                    2540,  6066,  3638,  7538,  6257,  629,  7330,  1581,  7669,  3444,  50, 
                                    4562,  1871,  1361,  7786,  4641,  5206,  4409,  1298,  6859,  2946,  7065, 
                                    8772,  4612,  541,  1537,  143,  1915,  6962,  3649,  3510,  4570,  7555, 
                                    2042,  7706,  9394,  7386,  609,  6475,  8390,  2938,  9829,  8564,  5934, 
                                    1800,  2192,  53,  8644,  178,  6746,  2712,  1735,  8945,  295,  2481, 
                                    7652,  4788,  5306,  5441,  3343,  7689,  5286,  5599,  450,  5338,  6788, 
                                    8521,  1065,  1286,  8145,  5543,  4850,  8690,  5719,  6254,  6801,  9249, 
                                    9861,  484,  5041,  3207,  287,  9465,  2701,  9861,  4681,  522,  6445, 
                                    788,  6275,  4258,  8267,  5975,  4562,  848,  9252,  3772,  6138,  972, 
                                    3420,  3367,  9854,  5257,  2698,  3460,  248,  9630,  1552,  3064,  5526, 
                                    6279,  7246,  2781,  3437,  5697,  2044,  2798,  564,  5871,  2791,  6887, 
                                    503,  6995,  1853,  8489,  2048,  7399,  8948,  6636,  7041,  4423,  6185, 
                                    1366,  2085,  3061,  3933,  7465,  6680,  9403,  6529,  9722,  671,  6967, 
                                    6907,  6091,  9767,  6354,  1296,  9466,  1725,  6441,  3885,  2748,  3110, 
                                    4496,  2375,  7172,  2763,  4279,  3243,  1704,  5756,  4679,  9464,  3134, 
                                    9058,  8792,  6911,  3497,  8067,  6273,  7967,  1344,  658,  1095,  6527, 
                                    4977,  9165,  9935,  112,  5403,  5094,  1840,  3924,  1346,  6451,  4080, 
                                    4263,  1509,  3665,  5451,  4664,  2123,  538,  9159,  9614,  2435,  8236, 
                                    5823,  3638,  6518,  8747,  6418,  692,  5255,  6734,  9118,  2058,  1618, 
                                    772,  9882,  8545,  3600,  2765,  6933,  6453,  4322,  8869,  5393,  9436, 
                                    813,  7522,  9411,  8976,  3093,  7558,  5833,  8848,  5956,  714,  9155, 
                                    2487,  5011,  3543,  3298,  5986,  7704,  7058,  4370,  7760,  1115,  2427, 
                                    5054,  8032,  4775,  4608,  1709,  6394,  8632,  8193,  7958,  8222,  88, 
                                    9364,  9969,  7681,  7504,  1475,  4178,  9228,  8227,  9949,  8282,  9638, 
                                    1671,  8491,  3640,  5878,  8835,  1541,  4841,  3036,  8230,  9267,  5747, 
                                    1735,  2491,  6031,  7003,  8646,  5122,  3900,  4164,  905,  8107,  9133, 
                                    8702,  8866,  8350,  1576,  1849,  3045,  8961,  5562,  7786,  1715,  599, 
                                    6520,  9313,  2583,  1675,  2567,  2297,  1734,  1645,  6583,  2432,  9874, 
                                    6599,  272,  9090,  6336,  4414,  381,  2931,  7458,  3235,  2941,  3763, 
                                    7192,  5840,  2787,  475,  3555,  2953,  1192,  4252,  3054,  1613,  4034, 
                                    5601,  4910,  3695,  610,  8997,  6498,  627,  4648,  1169,  7973,  2177, 
                                    3627,  7648,  2896,  3191,  863,  3103,  5678,  878,  3248,  4902,  6202, 
                                    4891,  8862,  1544,  2572,  2763,  4042,  6300,  2721,  292,  5259,  4490, 
                                    6346,  9934,  2268,  2354,  3480,  835,  9837,  1149,  1340,  6986,  1569, 
                                    2227,  6922,  4142,  6844,  3000,  4916,  2599,  9409,  5925,  8080,  4814, 
                                    4068,  9175,  5355,  4092,  1047,  1013,  8077,  4024,  124,  8826,  348, 
                                    6095,  8483,  9301,  2137,  2979,  4679,  2308,  4620,  7598,  2559,  4191, 
                                    5787,  9070,  4556,  4404,  2167,  6399,  8557,  178,  8308,  543,  3347, 
                                    6131,  2482,  476,  5952,  1128,  4776,  3323,  8725,  4868,  9032,  8236, 
                                    6043,  7376,  4537,  5729,  8950,  6096,  5959,  9348,  6480,  4617,  727, 
                                    3,  6670,  3550,  470,  9955,  7308,  9449,  4313,  8447,  4942,  9598, 
                                    2469,  2565,  5038,  1785,  2753,  4269,  5794,  3149,  5651,  5381,  6050, 
                                    4285,  2143,  8318,  9370,  3686,  2803,  6849,  3289,  740,  5901,  8903, 
                                    8515,  1717,  779,  9725,  310,  7548,  4320,  8741,  2746,  3365,  9504, 
                                    3714,  608,  3860,  5972,  4677,  1603,  569,  9158,  4891,  9344,  6891, 
                                    9266,  4939,  3393,  3697,  1978,  7999,  1571,  811,  9624,  7743,  5665, 
                                    6935,  9885,  123,  1455,  528,  6209,  1053,  7662,  7367,  5201,  3609, 
                                    6448,  1839,  697,  7533,  2518,  9074,  1017,  4107,  1027,  5965,  184, 
                                    5681,  3695,  3942,  7835,  6566,  247,  9842,  8845,  6899,  7575,  3340, 
                                    4875,  1219,  9877,  5284,  6217,  2501,  1312,  3190,  5991,  2930,  9123, 
                                    1808,  9702,  239,  6281,  380,  3595,  221,  2845,  5096,  6088,  4032 };
        
    public SortsTest(String testName) {
        super(testName);
    }

    /**
     * Test of selectionSort method, of class galago.Sorts.
     */
    public void testSelectionSort() {
        System.out.println("selectionSort");
        Integer[] integerArray = { 5, 9, 1, 2, 10, 17, 4, 18 };
        Comparator<Integer> comparator = new Comparator<Integer>() {
            public int compare( Integer one, Integer two ) {
                return one.intValue() - two.intValue();
            }                               
        };
        
        ArrayList<Integer> selectionList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Sorts.selectionSort( selectionList, comparator, 0, selectionList.size() );
    
        ArrayList<Integer> collectionsList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Collections.sort( collectionsList, comparator );
        
        assertEquals( selectionList.size(), integerArray.length );
        
        for( int i=0; i<selectionList.size(); i++ ) {
            assertEquals( selectionList.get(i).intValue(), collectionsList.get(i).intValue() );
        }
    }

    /**
     * Test of quicksort method, of class galago.Sorts.
     */
    public void testQuicksort() {
        System.out.println("quicksort");
        
        Comparator<Integer> comparator = new Comparator<Integer>() {
            public int compare( Integer one, Integer two ) {
                return one.intValue() - two.intValue();
            }                               
        };
        
        ArrayList<Integer> quickList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Sorts.quicksort( quickList, comparator, 0, quickList.size() );
        assertEquals( quickList.size(), integerArray.length );
    
        ArrayList<Integer> collectionsList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Collections.sort( collectionsList, comparator );
        
        for( int i=0; i<quickList.size(); i++ ) {
            assertEquals( quickList.get(i).intValue(), collectionsList.get(i).intValue() );
        }
    }
    
    public void testMultiWaySort() {
        System.out.println( "multiWaySort" );
        Comparator<Integer> comparator = new Comparator<Integer>() {
            public int compare( Integer one, Integer two ) {
                return one.intValue() - two.intValue();
            }                               
        };
        
        ArrayList<Integer> quickList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Sorts.multiWaySort( quickList, 100, comparator );
    
        ArrayList<Integer> collectionsList = new ArrayList<Integer>(Arrays.asList(integerArray));
        Collections.sort( collectionsList );
        assertEquals( quickList.size(), integerArray.length );
        
        for( int i=0; i<quickList.size(); i++ ) {
            assertEquals( quickList.get(i).intValue(), collectionsList.get(i).intValue() );
        }
    }
    
}
